<?php

class FormaLMS {
/* function to make the hash*/
static public function getHash($params) {
   
	  $key =  '[b]formakey[/b]';
      $secret_key = '[b]formasecret[/b]';
      
      $res =array('sha1'=>'', 'x_auth'=>'');

      $res['sha1']=sha1(implode(',', $params) . ',' . $secret_key);

      $res['x_auth']=base64_encode($key . ':' . $res['sha1']);
      
      return $res;
   }      

   static private function getDefaultHeader($x_auth) {
      
      
      $cloudUrl = 'http://localhost:8080/freefad/api/rest.php?q=' ;
      
      if(stripos($cloudUrl, 'http://')===false && stripos($cloudUrl, 'https://')===false)
            $cloudUrl = 'http://'.$cloudUrl;

      if(!empty($cloudUrl)){
         $host = parse_url($cloudUrl, PHP_URL_HOST);
         
         return array(
               "Host: " . ($host ? $host : ''),
               "Content-Type: multipart/form-data",
               'X-Authorization: FormaLMS ' . $x_auth
         );
      }
      
      return array();
      
   }

static public function call($action, $data_params) {

      // Import the URL from the plugin settings or from this file otherwise
      $cloudUrl = 'http://localhost:8080/freefad/api/rest.php?q=' ;
      
      if(!$cloudUrl){
         return false;
      }else{
         $cloudUrl = trim($cloudUrl);
      }
      
      $cloudUrl = str_ireplace('http://', '', $cloudUrl);
      $cloudUrl = str_ireplace('https://', '', $cloudUrl);

      $curl = curl_init();

      $hash_info = self::getHash($data_params);
      $http_header =self::getDefaultHeader($hash_info['x_auth']);

      $opt = array(
         CURLOPT_URL=>$cloudUrl . '/api/' . $action,
         CURLOPT_RETURNTRANSFER=>1,
         CURLOPT_HTTPHEADER=>$http_header,
         CURLOPT_POST=>0,
         CURLOPT_POSTFIELDS=>$data_params,
         CURLOPT_CONNECTTIMEOUT=>5, // Timeout to 5 seconds
         CURLOPT_SSL_VERIFYPEER=>false,
         CURLOPT_SSL_VERIFYHOST=>false,
      );
      
      curl_setopt_array($curl, $opt);

      // $output contains the output string
      $output = curl_exec($curl);
      
      // it closes the session
      curl_close($curl);
      
      return $output;
   }
}//end of class   


$testApiCall = new SimpleXMLElement(FormaLMS::call('auth/authenticate', array('username'=>'d.ravasco','password'=>'lamiapassword')));
$token = false;

if (isset($testApiCall->success))
 {   
   //echo "[+] User logged<br>";
   $token = $testApiCall->token;
   //echo "[+] Set token: $token<br>";
   //echo "[+] Try to gettin info with api ... ";
               

	$testApiCall = new SimpleXMLElement(FormaLMS::call('user/checkUsername', array('auth'=>$token,'userid'=>'d.ravasco')));
   if ( isset($testApiCall->success) && $testApiCall->success == true ) {
          var_dump($testApiCall);
   } else {
         echo "<span style='color:red'>FALLITO</span><br>";
   }

   } else {
	   echo "<span style='color:red'>FALLITO</span><br>";
   }

?>